Subject: Make action argument optional in ActionViewHelpers
Description

The action view helpers for links and URIs both require the action argument. These view helpers may be used to generate links within
the same action and templates may be shared across actions via partials. Thus, it would be helpful for the action to be an option
argument like the controller and other arguments.

History
#1 - 2009-08-10 01:37 - Jeff Segars
- File 4207.diff added

#2 - 2009-08-14 12:39 - Jochen Rau
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

Hi Bastian. Could you please take care of this issue?

#3 - 2009-08-31 10:16 - Bastian Waidelich

Hi Jeff,

sorry for the delay, the optional action argument makes perfect sense!
Only, there is an "issues" with that:
If I'd leave away the action argument, I'd expect the resulting URI not to contain the action at all, resulting in a call to the configured default action of the
current plugin..

Actually, that's how I just implemented it for the formViewHelper and Uri-/Link-ActionViewHelpers in 
http://forge.typo3.org/attachments/1553/3981_tx_fluid_adjustments_v1.patch

If we want it to work the way you describe (no action -> use the current action) we'd need to modify the UriBuilder:
From:

if ($actionName !== NULL) {
    $controllerArguments['action'] = $actionName;
}

To:

if ($actionName !== NULL) {
    $controllerArguments['action'] = $actionName;
} else {

2015-08-03 1/3

http://forge.typo3.org/attachments/1553/3981_tx_fluid_adjustments_v1.patch


    $controllerArguments['action'] = $this->request->getControllerActionName();
}

But I'm not sure if that really makes sense.. In the end you'd want to use the action link to create links to different actions?
Please correct me, if I'm missing something.

#4 - 2009-09-04 18:10 - Bastian Waidelich
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Since r1180 action argument of action viewhelpers is optional.
If action is not specified, it won't appear in the resulting URI thus linking to the default action of the specified controller.

#5 - 2009-09-04 18:20 - Jeff Segars

Hey Bastian,
For some reason I didn't get a notification on your first reply. Sorry for now responding sooner.

In my case, I'm using partials and a page browser view helper to display the same results from several different actions. When I navigate through the
page browser, it makes sense to keep the current action, no matter what that action is. Perhaps I can address this by assigning a variable for the
current action rather than leaving it out completely.

For most cases, your solution certainly makes more sense.

Thanks,
Jeff

#6 - 2009-09-04 18:54 - Bastian Waidelich

Jeff Segars wrote:

Hey Jeff,

Sorry for now responding sooner.

No problem.

In my case, I'm using partials and a page browser view helper to display the same results from several different actions.

I see. It might work to set the action explicitly in your page browser view helper then.. Something like:

public function render(..., $action = NULL, ...) {
    if ($action === NULL) {
        $request = $this->controllerContext->getRequest();
        $action = $request->getControllerActionName();
    }
    ...

Perhaps I can address this by assigning a variable for the current action rather than leaving it out completely.

That's another solution. You can pass arguments to the partial like this:

<f:render partial="foo" arguments="{action: 'bar'}" />

For most cases, your solution certainly makes more sense.

Well, I've discussed it with Sebastian and Jochen and they think the same.

Thanks for the feedback

#7 - 2009-10-21 17:52 - Bastian Waidelich
- Project changed from Extbase MVC Framework to TYPO3.Fluid
- Category deleted (432)

Files
4207.diff 2.4 kB 2009-08-10 Jeff Segars
